/*
 * Copyright (c) 2007 Alexey Vatchenko <av@bsdua.org>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _CDMA_CMOTECH_CCU550_H_
#define _CDMA_CMOTECH_CCU550_H_

#include <sys/types.h>

#include "cdma.h"

__BEGIN_DECLS
int	cmotech_ccu550_getlimit(struct cdma *ctx, enum cdma_limit what);

int	cmotech_ccu550_gettime(struct cdma *ctx, struct cdma_time *ct);

int	cmotech_ccu550_pininfo(struct cdma *ctx, int *flags);
int	cmotech_ccu550_pin_enable(struct cdma *ctx, const char *pin,
	    int toenable);
int	cmotech_ccu550_pin_change(struct cdma *ctx, const char *old,
	    const char *pin);
int	cmotech_ccu550_pin_enter(struct cdma *ctx, const char *pin);
int	cmotech_ccu550_puk_enter(struct cdma *ctx, const char *puk,
	    const char *pin);

int	cmotech_ccu550_getmode(struct cdma *ctx);
int	cmotech_ccu550_setmode(struct cdma *ctx, int mode);

int	cmotech_ccu550_sms_send(struct cdma *ctx, const char *dst,
	    const char *msg, size_t msgsz);
int	cmotech_ccu550_sms_read(struct cdma *ctx, struct cdma_sms *sms);
int	cmotech_ccu550_sms_check(struct cdma *ctx, u_int *n_sms);
int	cmotech_ccu550_sms_enum(struct cdma *ctx, cdma_sms_callback cb);
int	cmotech_ccu550_sms_delete(struct cdma *ctx, u_int index);
int	cmotech_ccu550_sms_save(struct cdma *ctx, const char *phone,
	    struct cdma_time *ct, const char *msg);

int	cmotech_ccu550_pb_enum(struct cdma *ctx, cdma_pb_callback cb);
int	cmotech_ccu550_pb_add(struct cdma *ctx, u_int index, const char *phone,
	    const char *name);
int	cmotech_ccu550_pb_delete(struct cdma *ctx, u_int index);
__END_DECLS

#endif /* !_CDMA_CMOTECH_CCU550_H_ */
