/*
 * Copyright (c) 2007 Alexey Vatchenko <av@bsdua.org>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _CDMA_UTIL_H_
#define _CDMA_UTIL_H_
#include <sys/types.h>

__BEGIN_DECLS
/*
 * ``Low-level'' routines.
 * They do all physical IO and initial parsing
 */
int	open_tty(const char *dev);
int	send_cmd(int fd, const char *cmd);
int	recv_answer(int fd, char **buf, size_t *bufsz, size_t *rdsz,
	    int *status);

#define ANSWER_OK		0
#define ANSWER_ERROR		1
#define ANSWER_UNKNOWN		255
int	end_of_answer(const char *buf, size_t bufsz, size_t *nl, int *status);

char *	get_line(const char *buf, size_t bufsz, char **n);
char *	get_tagged_line(const char *buf, size_t bufsz, const char *tag,
	    char **n);
char *	get_answer_array(const char *buf, size_t bufsz, size_t n,
	    const char *cmd);
int	read_stdin(char **buf, size_t *bufsz, size_t *rdsz);
__END_DECLS

#endif /* !_CDMA_UTIL_H_ */
